import cmdlib, effectlib, es, keyvalues, langlib, os.path, playerlib, popuplib, repeat, services
from es import server_var

info = es.AddonInfo()
info.name = 'Anti Rush'
info.version = '1.7'
info.author = 'Glodny'

es.ServerVar('anti_rush_version', str(info.version)).makepublic()

adding_fence = es.ServerVar('adding_fence', 0)
adding_zone = es.ServerVar('adding_zone', 0)
anti_rush = es.ServerVar('anti_rush', 0)
rush_allowed = es.ServerVar('rush_allowed', 0)
norushtime = es.ServerVar('ar_norushtime', 120)
checktime = es.ServerVar('ar_checktime', 1)
last_man_rushing = es.ServerVar('ar_last_man_rushing', 0)
punishment = es.ServerVar('ar_punishment', 1)
bantime = es.ServerVar('ar_bantime', 10)
admin_immunity = es.ServerVar('ar_admin_immunity', 0)
beam = es.ServerVar('ar_beam', 1)
red_amount = es.ServerVar('ar_red_amount', 255)
green_amount = es.ServerVar('ar_green_amount', 0)
blue_amount = es.ServerVar('ar_blue_amount', 0)

active_zones = None
auth = services.use('auth')
change_zone = None
fencelist = ['fence_1', 'fence_2', 'fence_3', 'fence_4', 'fence_5', 'fence_6', 'fence_7', 'fence_8', 'fence_9', 'fence_10']
manage_zone = None
popuplist = ['active_zones', 'change_zone', 'manage_zone', 'zones_popup']
text = None
tokens = {}
zonelist = ['zone_1', 'zone_2', 'zone_3', 'zone_4', 'zone_5', 'zone_6', 'zone_7', 'zone_8', 'zone_9', 'zone_10']
zones = None
zones_popup = None

def load():
    global text
    es.doblock('corelib/noisy_on')
    text = langlib.Strings(es.getAddonPath('anti_rush') + '/strings.ini')
    if os.path.isfile(es.getAddonPath('anti_rush') + '/anti_rush.cfg'):
        es.server.cmd('es_xmexec ../addons/eventscripts/anti_rush/anti_rush.cfg')
    else:
        es.dbgmsg(0, text('error'))
    auth.registerCapability('anti_rush_admin', auth.ADMIN)
    cmdlib.registerSayCommand('!zones', zonescmd, 'zonescmd', 'anti_rush_admin', 'ADMIN')
    loop = 1
    repeat.create('fences', fences, loop)
    repeat.create('rush', rush, loop)
    check_map()

def unload():
    es.doblock('corelib/noisy_off')
    cmdlib.unregisterSayCommand('!zones')
    repeat.delete('fences')
    repeat.delete('rush')
    for zone in zonelist:
        if es.exists('keyvalue', zones, current_map, zone):
            es.server.cmd('est_Box_Remove %s' %zone)
    if es.exists('keygroup', 'zones', '|anti_rush'):
        es.keygroupdelete('zones')
    for popup in popuplist:
        if popuplib.exists(popup):
            popuplib.delete(str(popup))

def round_freeze_end(event_var):
    check_map()
    if anti_rush:
        rush_allowed.set('0')
        tokens['norushtime'] = str(norushtime)
        if 'cs_' in current_map:
            es.msg('#multi', text('announcement 1'))
            es.msg('#multi', text('announcement 2', tokens))
        elif 'de_' in current_map:
            es.msg('#multi', text('announcement 3'))
            es.msg('#multi', text('announcement 4', tokens))
        repeat.start('rush', norushtime, 1)
        if beam:
            repeat.start('fences', 1, norushtime)
        for zone in zonelist:
            if es.exists('keyvalue', zones, current_map, zone):
                es.server.cmd('est_Box_Remove %s' %zone)
            if es.exists('keyvalue', zones, current_map, zone):
                (x1, y1, z1) = es.splitvectorstring(zones[str(current_map)]['%s_v1' %zone])
                (x2, y2, z2) = es.splitvectorstring(zones[str(current_map)]['%s_v2' %zone])
                es.server.cmd('est_Box_Trigger %s %s "%s %s %s" "%s %s %s" %s' %(filter2, zone, x1, y1, z1, x2, y2, z2, checktime))

def player_death(event_var):
    if anti_rush and not rush_allowed and last_man_rushing:
        t = playerlib.getPlayerList('#alive,#t')
        ct = playerlib.getPlayerList('#alive,#ct')
        if len(t) == 1 and len(ct) == 1:
            rush_allowed.set('1')
            filtername = filter.replace('#', '')
            es.msg('#multi', text('last man rushing %s' %filtername))
            repeat.stop('rush')
            if beam:
                repeat.stop('fences')
        elif len(t) == 1:
            rush_allowed.set('1')
            es.msg('#multi', text('last man rushing t'))
            repeat.stop('rush')
            if beam:
                repeat.stop('fences')
        elif len(ct) == 1:
            rush_allowed.set('1')
            es.msg('#multi', text('last man rushing ct'))
            repeat.stop('rush')
            if beam:
                repeat.stop('fences')

def bomb_planted(event_var):
    if anti_rush and not rush_allowed:
        rush_allowed.set('1')
        es.msg('#multi', text('bomb planted'))
        repeat.stop('rush')
        if beam:
            repeat.stop('fences')

def hostage_follows(event_var):
    if anti_rush and not rush_allowed:
        rush_allowed.set('1')
        es.msg('#multi', text('hostage follows'))
        repeat.stop('rush')
        if beam:
            repeat.stop('fences')

def round_end(event_var):
    if anti_rush and not rush_allowed:
        rush_allowed.set('1')
        repeat.stop('rush')
        if beam:
            repeat.stop('fences')

def est_box_trigger(event_var):
    if anti_rush and not rush_allowed:
        userid = int(event_var['userid'])
        if not es.isbot(userid) and not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
            if admin_immunity and auth.isUseridAuthorized(userid, 'anti_rush_admin'):
                es.tell(userid, '#multi', text('rush', lang=playerlib.getPlayer(userid).get('lang')))
            else:
                tokens['name'] = es.getplayername(userid)
                if punishment == 1:
                    rusher = playerlib.getPlayer(userid)
                    rusher.kill()
                    es.msg('#multi', text('slayed', tokens))
                elif punishment == 2:
                    reason = text('reason', lang=playerlib.getPlayer(userid).get('lang'))
                    es.server.cmd('kickid %s %s' %(userid, reason))
                    es.msg('#multi', text('kicked', tokens))
                elif punishment == 3:
                    reason = text('reason', lang=playerlib.getPlayer(userid).get('lang'))
                    es.server.cmd('banid %s %s kick' %(bantime, userid))
                    es.msg('#multi', text('banned', tokens))

def bullet_impact(event_var):
    if adding_fence or adding_zone:
        userid = int(event_var['userid'])
        if auth.isUseridAuthorized(userid, 'anti_rush_admin'):
            global shot
            shot = shot + int(1)
            if shot == 1:
                global temp_x1, temp_y1, temp_z1
                temp_x1 = float(event_var['x'])
                temp_y1 = float(event_var['y'])
                temp_z1 = float(event_var['z'])
                temp_z1 += int(1)
            elif shot == 2:
                global temp_x2, temp_y2, temp_z2, temp_corner1, temp_corner2
                temp_x2 = float(event_var['x'])
                temp_y2 = float(event_var['y'])
                temp_z2 = float(event_var['z'])
                temp_z2 += int(1)
                temp_corner1 = es.createvectorstring(temp_x1, temp_y1, temp_z1)
                temp_corner2 = es.createvectorstring(temp_x2, temp_y2, temp_z2)
                if adding_fence:
                    global adding_fence_popup
                    es.server.cmd('est_effect 3 #all 0 sprites/laser.vmt %s %s %s %s %s %s 5 5 5 255 0 0 255' %(temp_x1, temp_y1, temp_z1, temp_x2, temp_y2, temp_z2))
                    adding_fence_popup = popuplib.create('adding_fence_popup')
                    adding_fence_popup.addline('%s' %text('adding fence'))
                    adding_fence_popup.addline('->1. %s' %text('show fence'))
                    adding_fence_popup.addline('->2. %s' %text('save fence'))
                    adding_fence_popup.addline('->0. %s' %text('close'))
                    adding_fence_popup.menuselect = addingfence
                    adding_fence_popup.send(userid)
                elif adding_zone:
                    global adding_zone_popup
                    effectlib.drawBox(temp_corner1, temp_corner2, seconds=5, red=255, green=0, blue=0, brightness=255)
                    adding_zone_popup = popuplib.create('adding_zone_popup')
                    adding_zone_popup.addline('%s' %text('adding zone'))
                    adding_zone_popup.addline('->1. %s' %text('show zone'))
                    adding_zone_popup.addline('->2. %s' %text('save zone'))
                    adding_zone_popup.addline('->0.  %s' %text('close'))
                    adding_zone_popup.menuselect = addingzone
                    adding_zone_popup.send(userid)

def check_map():
    global current_map, zones
    current_map = str(server_var['eventscripts_currentmap'])
    if es.exists('keygroup', 'zones', '|anti_rush'):
        es.keygroupdelete('zones', '|anti_rush')
    es.keygroupload('zones', '|anti_rush')
    zones = keyvalues.getKeyGroup('zones')
    if es.exists('key', zones, current_map):
        global filter, filter2
        anti_rush.set('1')
        if 'cs_' in current_map:
            filter = '#t'
            filter2 = '#t'
        elif 'de_' in current_map:
            filter = '#ct'
            filter2 = '#c'
    else:
        anti_rush.set('0')

def fences(loop):
    for fence in fencelist:
        if es.exists('keyvalue', zones, current_map, fence):
            (x1, y1, z1) = es.splitvectorstring(zones[str(current_map)]['%s_v1' %fence])
            (x2, y2, z2) = es.splitvectorstring(zones[str(current_map)]['%s_v2' %fence])
            playerlist = playerlib.getPlayerList(filter)
            if len(playerlist) > 0:
                es.server.cmd('est_effect 3 %s 0 sprites/laser.vmt %s %s %s %s %s %s 1 5 5 %s %s %s 255' %(filter, x1, y1, z1, x2, y2, z2, red_amount, green_amount, blue_amount))

def rush(loop):
    rush_allowed.set('1')
    es.msg('#multi', text('rush allowed'))
    if beam:
        repeat.stop('fences')

def zonescmd(userid, args):
    global shot
    adding_fence.set('0')
    adding_zone.set('0')
    shot = 0
    zones_popup = popuplib.create('zones_popup')
    zones_popup.addline('%s: %s' %(text('map'), current_map))
    zones_popup.addline('->1. %s' %text('active zones'))
    zones_popup.addline('->2. %s' %text('add fence'))
    zones_popup.addline('->3. %s' %text('add zone'))
    zones_popup.addline('->0. %s' %text('close'))
    zones_popup.menuselect = zonespopup
    zones_popup.send(userid)

def zonespopup(userid, choice, popupname):
    if choice == 1:
        global zones
        if es.exists('keygroup', 'zones', '|anti_rush'):
            es.keygroupdelete('zones', '|anti_rush')
        es.keygroupload('zones', '|anti_rush')
        zones = keyvalues.getKeyGroup('zones')
        active_zones = popuplib.easymenu('active_zones', None, activezones)
        active_zones.settitle('%s:' %text('active zones'))
        for zone in zonelist:
            if es.exists('keyvalue', zones, current_map, zone):
                active_zones.addoption(zone, zone)
        active_zones.submenu(0, 'zones_popup')
        active_zones.send(userid)
    elif choice == 2:
        adding_fence.set('1')
        es.tell(userid, '#multi', text('adding fence instruction', lang=playerlib.getPlayer(userid).get('lang')))
    elif choice == 3:
        adding_zone.set('1')
        es.tell(userid, '#multi', text('adding zone instruction', lang=playerlib.getPlayer(userid).get('lang')))

def activezones(userid, choice, popupname):
    global manage_zone, temp_zone
    temp_zone = choice
    manage_zone = popuplib.create('manage_zone')
    manage_zone.addline('%s: %s' %(text('manage zone'), temp_zone))
    manage_zone.addline('->1. %s' %text('show zone'))
    manage_zone.addline('->2. %s' %('%s_v1' %temp_zone))
    manage_zone.addline('->3. %s' %('%s_v2' %temp_zone))
    manage_zone.addline('->9. %s' %text('back'))
    manage_zone.addline('->0. %s' %text('close'))
    manage_zone.menuselect = managezone
    manage_zone.send(userid)

def managezone(userid, choice, popupname):
    if choice == 1:
        temp_zone_v1 = zones[str(current_map)]['%s_v1' %temp_zone]
        temp_zone_v2 = zones[str(current_map)]['%s_v2' %temp_zone]
        effectlib.drawBox(temp_zone_v1, temp_zone_v2, seconds=5, red=255, green=0, blue=0, brightness=255)
        manage_zone.send(userid)
    elif choice == 2:
        global temp_coord, temp_zone
        (temp_x, temp_y, temp_z) = es.splitvectorstring(zones[str(current_map)]['%s_v1' %temp_zone])
        change_zone = popuplib.create('change_zone')
        change_zone.addline('%s: %s_v1' %(text('coordinate'), temp_zone))
        temp_coord = zones[str(current_map)]['%s_v2' %temp_zone]
        temp_zone = '%s_v1' %temp_zone
    elif choice == 3:
        global temp_coord, temp_zone
        (temp_x, temp_y, temp_z) = es.splitvectorstring(zones[str(current_map)]['%s_v2' %temp_zone])
        change_zone = popuplib.create('change_zone')
        change_zone.addline('%s: %s_v2' %(text('coordinate'),temp_zone))
        temp_coord = zones[str(current_map)]['%s_v1' %temp_zone]
        temp_zone = '%s_v2' %temp_zone
    elif choice == 9:
        popuplib.close('manage_zone', userid)
        popuplib.send('active_zones', userid)
    elif choice == 10:
        popuplib.close('manage_zone', userid)
    if choice == 2 or choice == 3:
        global change_zone, temp_x, temp_y, temp_z
        change_zone.addline('->1. %s X' %text('add to'))
        change_zone.addline('->2. %s Y' %text('add to'))
        change_zone.addline('->3. %s Z' %text('add to'))
        change_zone.addline('->4. %s X' %text('subtract from'))
        change_zone.addline('->5. %s Y' %text('subtract from'))
        change_zone.addline('->6. %s Z' %text('subtract from'))
        change_zone.addline('->7. %s' %text('show zone'))
        change_zone.addline('->8. %s' %text('save changes'))
        change_zone.addline('->0. %s' %text('close'))
        change_zone.menuselect = changezone
        change_zone.send(userid)

def changezone(userid, choice, popupname):
    global temp_x, temp_y, temp_z
    if choice == 1:
        temp_x = temp_x + int(5)
    elif choice == 2:
        temp_y = temp_y + int(5)
    elif choice == 3:
        temp_z = temp_z + int(5)
    elif choice == 4:
        temp_x = temp_x - int(5)
    elif choice == 5:
        temp_y = temp_y - int(5)
    elif choice == 6:
        temp_z = temp_z - int(5)
    elif choice == 7:
        temp_xyz = es.createvectorstring(temp_x, temp_y, temp_z)
        effectlib.drawBox(temp_xyz, temp_coord, seconds=5, red=255, green=0, blue=0, brightness=255)
    elif choice == 8:
        zones[current_map][temp_zone] = '%i,%i,%i' %(temp_x, temp_y, temp_z)
        es.keygroupsave('zones', '|anti_rush')
    elif choice == 10:
        popuplib.close('change_zone', userid)
    if choice < 7:
        temp_xyz = es.createvectorstring(temp_x, temp_y, temp_z)
        effectlib.drawBox(temp_xyz, temp_coord, seconds=5, red=255, green=0, blue=0, brightness=255)
    if choice < 8:
        change_zone.send(userid)

def addingfence(userid, choice, popupname):
    if choice == 1:
        es.server.cmd('est_effect 3 #all 0 sprites/laser.vmt %s %s %s %s %s %s 5 5 5 255 0 0 255' %(temp_x1, temp_y1, temp_z1, temp_x2, temp_y2, temp_z2))
        adding_fence_popup.send(userid)
    elif choice == 2:
        number = 0
        for fence in fencelist:
            if es.exists('keyvalue', zones, current_map, fence):
                number = number + int(1)
        if not es.exists('key', zones, current_map):
            zones[current_map] = keyvalues.KeyValues(name=current_map)
        number = number + int(1)
        zones[current_map]['fence_%i' %number] = 1
        zones[current_map]['fence_%i_v1' %number] = '%i,%i,%i' %(temp_x1, temp_y1, temp_z1)
        zones[current_map]['fence_%i_v2' %number] = '%i,%i,%i' %(temp_x2, temp_y2, temp_z2)
        es.keygroupsave('zones', '|anti_rush')
    elif choice == 10:
        popuplib.close('adding_fence_popup', userid)

def addingzone(userid, choice, popupname):
    if choice == 1:
        effectlib.drawBox(temp_corner1, temp_corner2, seconds=5, red=255, green=0, blue=0, brightness=255)
        adding_zone_popup.send(userid)
    elif choice == 2:
        number = 0
        for zone in zonelist:
            if es.exists('keyvalue', zones, current_map, zone):
                number = number + int(1)
        if not es.exists('key', zones, current_map):
            zones[current_map] = keyvalues.KeyValues(name=current_map)
        number = number + int(1)
        zones[current_map]['zone_%i' %number] = 1
        zones[current_map]['zone_%i_v1' %number] = '%i,%i,%i' %(temp_x1, temp_y1, temp_z1)
        zones[current_map]['zone_%i_v2' %number] = '%i,%i,%i' %(temp_x2, temp_y2, temp_z2)
        es.keygroupsave('zones', '|anti_rush')
    elif choice == 10:
        popuplib.close('adding_zone_popup', userid)